Index: /trunk/LMDZ.GENERIC/utilities/formats.inc
===================================================================
--- /trunk/LMDZ.GENERIC/utilities/formats.inc	(revision 253)
+++ /trunk/LMDZ.GENERIC/utilities/formats.inc	(revision 253)
@@ -0,0 +1,42 @@
+ 10   format(a)
+ 11   format(I1)
+ 12   format(I2)
+ 13   format(I3)
+ 14   format(I4)
+ 15   format(I5)
+ 16   format(I6)
+ 17   format(I7)
+ 18   format(I8)
+ 19   format(I9)
+ 110   format(I10)
+ 20   format(a23,I3,I3)
+ 21   format(a1)
+ 22   format(i3,a1,a10)
+ 30   format(a30,i3)
+ 31   format(a18,i3)
+ 32   format(a22,i3,a1,i3)
+ 33   format(a23,i3,a1,i3)
+ 34   format(a21,i3)
+ 35   format(a36,i3)
+ 36   format(a3,e17.9,a9,i4)
+   37   format(I1,I9,a100)
+   38   format(I9,a100)
+   39   format(a30,i3)
+   40  format(a,f9.3,a,f9.3,a)
+   41 format(a,f9.3,a)
+   42 format(a,I3,a,I3,a,I3,a)
+   43 format(a,I3,a)
+   44 format(I2,a)
+   45 format(I2,a,I2,a)
+   46 format(I2,a,I2,a,I2,a)
+   47 format(I2,a,I2,a,I2,a,I2,a)
+ 50   format(1000e17.9)
+ 51   format(I3,1000e17.9)
+ 52   format(1000e23.15)
+ 60   format(I2,I1,F12.6,2E10.3,2F5.4,F10.4,F4.2,F8.6,! &
+     &       4A15,6I1,6I2,A1,2F7.1)
+ 62   format(i12,F13.5,F14.4,i5,E14.6)
+ 63   format(I2)
+ 70   format(I2,I1,F12.6,1P2E10.3,0P2F5.4,F10.4,F4.2,F8.6,! &
+     &       2I3,2A9,3I1,3I2)
+ 80   format(I2,I1,F12.6)
Index: /trunk/LMDZ.GENERIC/utilities/generate_kmatrix.F90
===================================================================
--- /trunk/LMDZ.GENERIC/utilities/generate_kmatrix.F90	(revision 253)
+++ /trunk/LMDZ.GENERIC/utilities/generate_kmatrix.F90	(revision 253)
@@ -0,0 +1,461 @@
+      program generate_kmatrix
+      implicit none
+
+!     -------------------------------------------------------------
+!     Purpose: to read hires spectra and produce kdistribution data
+!     Authour: Robin Wordsworth (2010)
+!     -------------------------------------------------------------
+
+      integer nmolec,mol
+      integer i,j,k,im
+      integer Nb
+
+      character*4 fname
+      character*32 fnum
+
+      integer iT, iP, iQ, Nlevs
+
+      double precision nuT, sigT, kT
+
+      integer Nq
+      parameter (Nq=16) ! we choose this here
+
+      integer Nmax
+      parameter (Nmax=1000) ! maximum number of levels
+
+      integer Nmol_max
+      parameter (Nmol_max=10) ! maximum number of radiatively active species
+
+      integer Nkmax
+      ! large array = slow calculation... this makes a huge difference
+      !parameter (Nkmax=50000) ! works for IR, 27 bands
+      !parameter (Nkmax=100000) ! works for IR, 27 bands
+      !parameter (Nkmax=140000) ! works for IR, 32 bands
+      !parameter (Nkmax=250000) ! works for VI, 36 bands
+      parameter (Nkmax=400000) ! works for IR, 8 bands
+      !parameter (Nkmax=400000) ! works for VI, 12 bands
+      !parameter (Nkmax=200000) ! works for IR, 30 bands
+
+      integer NbMAX
+      parameter (NbMAX=100)
+
+      integer Ngres
+      parameter (Ngres=200)
+
+      character*10 molec_names(1:Nmol_max)
+      double precision T(1:Nmax), P(1:Nmax), Q(1:Nmax)
+
+
+      double precision pi
+      parameter (pi=3.14159265)
+      double precision x
+      double precision y(1:Nq+2)
+
+      double precision nu_min(1:NbMAX) ! make allocatable?
+      double precision nu_max(1:NbMAX)
+
+      integer quad, band
+
+      double precision ktemp(1:Nq)
+      double precision w(1:Nq), gw(1:Nq)
+
+      double precision, allocatable :: kdist_temp(:)
+      double precision, allocatable :: kdist(:,:,:,:,:)
+
+      double precision nuband(1:Nkmax), kband(1:Nkmax), nuwband(1:Nkmax) ! better static I think
+      double precision nuwbtot
+
+      double precision gfine(1:Ngres)      
+      double precision klevs(1:Ngres)
+      double precision addline(1:Nkmax)
+
+      double precision kmax, kmin, lkmax, lkmin, dlogK, klev
+      integer ic, ib, ig, ik1, ik2
+
+      integer filerr
+      logical filexi
+
+      logical addCIA
+      integer iCO2
+      double precision k1,k2,kCIA,amg,Pp
+
+      real truemean, distmean, etot
+      
+
+      addCIA=.false.
+
+      print*,'Creating the GCM correlated-k data...'
+      print*,' '
+
+      !--------------------------------------------------------
+      ! load temperature, pressure, mixing ratio data
+      open(9,file='T.dat')
+      read(9,*) iT
+      do i=1,iT
+         read(9,*) T(i)
+      enddo
+      close(9)
+
+      open(10,file='p.dat')
+      read(10,*) iP
+      do i=1,iP
+         read(10,*) P(i)
+         P(i)=10.**P(i)  ! note we keep P in millibars for the conversion later
+      enddo
+      close(10)
+
+      open(11,file='Q.dat')
+      read(11,*) nmolec
+      do mol=1,nmolec
+         read(11,*) molec_names(mol)
+      enddo
+      read(11,*) iQ
+      do i=1,iQ
+         read(11,*) Q(i)
+      enddo
+      close(11)
+
+      Nlevs=iT*iP*iQ ! total number of layers
+
+      print*,'Temperature layers:  ',iT
+      print*,'Pressure layers:     ',iP
+      print*,'Mixing ratio layers: ',iQ
+      print*,'Total:               ',Nlevs
+
+
+      if(addCIA)then
+
+         if(nmolec.gt.2)then
+            print*,'I cant deal with this situation yet'
+            call abort
+         endif
+
+         iCO2=0
+         do mol=1,nmolec
+            if(molec_names(mol).eq.'CO2')then
+               iCO2=mol
+            endif
+         enddo
+
+         !if(iCO2.eq.1)then
+         print*,' '
+         print*,'--- Adding CO2 CIA ---'
+         !else
+         !   print*,'Warning, not CO2+H2O mixture, need CO2 mixing ratio'
+         !   call abort
+         !endif
+      endif
+
+      !--------------------------------------------------------
+      ! load spectral data
+      open(12,file='narrowbands.in')
+      read(12,*) Nb
+
+      do band=1,Nb
+         read(12,*) nu_min(band),nu_max(band)
+      enddo
+      close(12)
+
+      print*,' '
+      print*,'Number of spectral bands: ',Nb
+
+      print*,'Band limits:'
+      do band=1,Nb
+         print*,band,'-->',nu_min(band),nu_max(band),' cm^-1'
+      end do
+
+      !--------------------------------------------------------
+      ! create g-space data
+      do quad=0,Nq+1
+         x=dble(quad)/dble(Nq+2)
+         !y(quad+1)=sin(pi*x)*exp(-5*x)
+         !y(quad+1)=sin(pi*x)*exp(-9*x)  ! CO2_H2Ovar 38x36
+         y(quad+1)=sin(pi*x)*exp(-12*x)
+         !y(quad+1)=sin(pi*x)*exp(-15*x) ! CO2_CH4
+      enddo
+
+      do quad=1,Nq
+         w(quad)=y(quad+1)
+      enddo
+      w=w/sum(w)
+
+      print*,' '
+      print*,'Number of g-space intervals: ',Nq
+
+      print*,'g-space weighting:'
+      do quad=1,Nq
+         print*,quad,'-->',w(quad)
+      end do
+
+      ! write g-space data
+      open(14,file='g.dat')
+      write(14,*) Nq+1
+
+      do quad=1,Nq
+         write(14,*) w(quad)
+      enddo
+      write(14,*) 0.0
+      close(14)
+
+      ! cumulative sum for g-vector
+      gw(1)=w(1)
+      do quad=2,Nq
+         gw(quad)=gw(quad-1)+w(quad)
+      enddo
+
+      ! allocate 5D matrices
+      allocate(kdist_temp(Nq))
+      allocate(kdist(iT,iP,iQ,Nb,Nq+1))
+
+
+      nuT=0.0
+      do i=1,iQ
+         do j=1,iP
+
+
+            if(addCIA.and.(iCO2.eq.1))then 
+               Pp=P(j)*(1.0-Q(i))
+            else
+               Pp=P(j)*Q(i)
+            endif
+            !if(addCIA) Pp=P(j)*(1.0-Q(i))
+
+
+            do k=1,iT             
+               im = (i-1)*iP*iT + (j-1)*iT + k
+
+               !-----------------------------------------------
+               ! open kspectrum file
+               write(fnum,*) im
+               if(im<10)then
+                   fname='k00'//trim(adjustl(fnum))
+               elseif(im<100)then
+                   fname='k0'//trim(adjustl(fnum))
+               else
+                   fname='k'//trim(adjustl(fnum))
+               endif
+
+               ! check that the file exists
+               inquire(FILE='hires_spectrum/'//fname,EXIST=filexi)
+               if(.not.filexi) then
+                  write(*,*)'The file ',fname(1:LEN_TRIM(fname))
+                  write(*,*)'was not found in the folder hires_spectrum, exiting.'
+                  call abort
+               endif
+
+               print*,'Opening file ',fname(1:LEN_TRIM(fname))
+               open(17,file='hires_spectrum/'//fname)
+
+               nuT=0.0
+               do band=1,Nb
+               print*,'Band ---> ',band
+
+                  !--------------------------------------------
+                  ! write kdata to temporary band arrays
+                  ! and find max / min k-values in band
+                  do while (nuT.lt.nu_min(band))
+                      read(17,*,IOSTAT=filerr) nuT, sigT, kT
+                   ! ideally need to catch all errors here (ask Ehouarn)
+                      if(filerr.lt.0)then
+                         print*,    &
+                             'nu_min greater than highest value in file'
+                         print*,'IOSTAT=',filerr
+                         print*,'nu_min=',nu_min(band)
+                         print*,'nu_endoffile=',nuT
+                         call abort
+                      endif
+                  enddo
+
+                  ic=1
+                  kmin=kT
+                  kmax=kT
+                  nuband(:)=0
+                  kband(:)=0
+
+                  do while (nuT.lt.nu_max(band))
+
+                      nuband(ic)=nuT
+                      kband(ic)=kT
+
+                      ! insert CIA option here
+                      if(addCIA)then
+
+                         k1=0.0
+                         k2=0.0
+                         if(nuT.lt.500.0) call getspc(T(k),nuT,k1)
+                         if((nuT.gt.1000.0).and.(nuT.lt.1800.0)) call baranov(T(k),nuT,k2)
+                         ! cm^-1.amagat^2
+
+                         amg=273.15D+0/T(k)*(Pp/1013.25) ! amagats of CO2
+
+                         kCIA=(k1+k2)*1.0D+2*amg**2.0D+0 ! m^-1
+                         kband(ic)=kband(ic)+kCIA
+                   	 kT=kband(ic)
+
+                         !kband(ic)=kCIA
+			 !kT=kCIA
+			 !if(nuband(ic).gt.1250.0)then
+			 !	print*,'P=',P(i)
+			 !	print*,'T=',T(k)
+		         !	print*,'amg=',amg
+			 !	print*,'nu=',nuband(ic)
+                         !       print*,'k1=',k1
+                         !       print*,'k2=',k2
+                         !       print*,'kCIA=',kCIA
+		  	 !	call abort
+                         !endif
+
+                      endif
+
+                      if(kT.lt.kmin)then
+                        kmin=kT
+                      endif
+                      if(kT.gt.kmax)then ! bug corrected!
+                        kmax=kT
+                      endif
+
+                      read(17,*,IOSTAT=filerr) nuT, sigT, kT
+                      if(filerr.lt.0)then
+                         print*,    &
+                             'nu_max greater than highest value in file'
+                         print*,'IOSTAT=',filerr
+                         print*,'nu_max=',nu_max(band)
+                         print*,'nu_endoffile=',nuT
+                         call abort
+                      endif
+
+
+                      ic=ic+1
+                      
+                      if(ic.gt.Nkmax)then
+                         print*,'Spectral resolution too low for these bands, exiting!'
+                         print*,'Increase Nkmax in generate_kmatrix.F90.'
+                         call abort
+                      endif
+
+                  enddo
+                  nuband(ic)=nuT
+                  kband(ic)=kT
+
+                  if(kmax.le.0.0)then
+                  !if(kmax.le.1.0e-15)then
+                     print*,'kmax=',kmax
+                     print*,'Setting values to zero in this band.'
+                     kdist(k,j,i,band,1:(Nq+1))=0.0
+                  else
+
+                  if(kmin.lt.1e-30)then
+                     kmin=1.0e-30
+                  endif
+
+                  !--------------------------------------------
+                  ! calculate delta nu values
+                  nuwband(:)=0.0
+                  do ib=2,(ic-1)
+                      nuwband(ib)=(nuband(ib+1)-nuband(ib-1))/2
+                  enddo
+                  nuwband(1)=nuwband(2)
+                  nuwband(ic)=nuwband(ic-1) ! causes tiny boundary error; whatever
+                  nuwbtot=sum(nuwband)
+
+                  lkmax=log10(kmax)
+                  lkmin=log10(kmin)
+                  
+                  dlogK=(lkmax-lkmin)/(Ngres-1)                 
+
+                  !--------------------------------------------
+                  ! calculate the g function
+                  gfine(:)=0.0
+                  do ig=1,Ngres
+                    klev=lkmin + dble(ig)*dlogK
+                    klev=10**klev
+                    klevs(ig)=klev
+
+                    addline(:)=0
+                    do ib=1,ic
+                        if(kband(ib).lt.klev)then
+                           addline(ib)=1.0
+                        endif
+                    enddo
+                    gfine(ig)=sum(addline(:)*nuwband(:))/nuwbtot
+
+                  enddo
+                  print*,'gnorm    = ',gfine(Ngres)
+
+                  !--------------------------------------------
+                  ! invert the g function
+                  ik1=1
+                  ik2=1
+                  kdist_temp(:)=0.0
+                  do quad=1,Nq
+                    
+                    ik2=ik1
+
+                    gfind: do while (gfine(ik2).lt.gw(quad))
+                       ik2=ik2+1
+                       if(ik2.gt.Ngres)then
+                          print*,'g-inversion overflow...'
+                          ik2=Ngres
+                          exit gfind
+                       endif
+                    enddo gfind
+
+                    !if(ik2.gt.Ngres)then ! avoid out-of-bounds on final step
+                    !   ik2=Ngres
+                    !endif
+
+
+                     if(.not.(ik1.ge.ik2))then ! this could probably be improved
+                        !kdist_temp(quad)=sum(klevs(ik1:ik2))/(ik2-ik1) ! a bug was here!
+                        kdist_temp(quad)=sum(klevs(ik1:ik2))/(ik2+1-ik1)
+
+
+                     elseif(quad.ne.1)then
+                        kdist_temp(quad)=kdist_temp(quad-1)
+                     else
+                        kdist_temp(quad)=kmin
+                     endif
+
+                     !-----------------------------------------
+                     ! assign to 5D matrix and convert to cm^2 / molecule
+                     kdist(k,j,i,band,quad)=1.3807e-21 *               &
+                                kdist_temp(quad) * T(k)/P(j)
+
+                     ik1=ik2
+                  enddo ! g-space
+                  kdist(k,j,i,band,Nq+1)=0.0
+
+                  truemean = sum(kband(1:ic)*nuwband(1:ic))/sum(nuwband(1:ic))
+                  distmean = sum(kdist_temp(:)*w(:))/sum(w)
+                  etot     = 100*abs(truemean-distmean)/(distmean+truemean)
+                  print*,'truemean = ',truemean
+                  print*,'distmean = ',distmean
+                  !print*,'kdisttemp = ',kdist_temp(Nq)
+                  !print*,'kdistmax  = ',kmax
+                  print*,'etot (%) = ',etot
+                  !print*,'w  = ',w
+
+                  endif ! if kmax .le. 0.0 
+
+               enddo ! bands
+
+            enddo
+         enddo
+      enddo
+
+      !--------------------------------------------------------
+      ! save data and clean up
+      close(17)
+      open(14,file='corrk_gcm.dat',form='formatted')
+      write(14,*) kdist
+      close(14)
+      print*,' '
+      print*,'Correlated-k data saved in corrk_gcm.dat'
+      print*,' '
+      print*,'Now you must change the values of L_NTREF etc. in radinc_h.F90 (if necessary)'
+      print*,'and the variable "corrkdata" in callphys.def'
+
+      deallocate(kdist_temp)
+      deallocate(kdist)
+
+    end program generate_kmatrix
Index: /trunk/LMDZ.GENERIC/utilities/make_composition_gen.for
===================================================================
--- /trunk/LMDZ.GENERIC/utilities/make_composition_gen.for	(revision 253)
+++ /trunk/LMDZ.GENERIC/utilities/make_composition_gen.for	(revision 253)
@@ -0,0 +1,161 @@
+      program make_composition_gen
+      implicit none
+
+!     -------------------------------------------------------------   
+!     Purpose: to create "composition.in" file readable by kspectrum
+!     Authour: Robin Wordsworth (2010)
+!     -------------------------------------------------------------
+
+      include 'max.inc'
+      include 'formats.inc'
+      integer strlen,nmolec,nlev_mf,mol,imf,ind,indf
+      integer i,j,k,im,m
+      integer nb,na,ne
+      double precision alt(1:Nmax)
+      double precision pres(1:Nmax)
+      double precision temp(1:Nmax)
+
+      double precision P_mf(1:Nmax)
+      double precision x(1:Nmax,1:Nmol_max)
+      double precision xlev(1:Nmol_max)
+      double precision xconst(1:Nmol_max)
+      character*100 composition_file,model_file
+      character*100 planet_descriptor
+      character*200 string
+      character*20 s
+      character*10 molec_names(1:Nmol_max),molname
+      character*1 spch
+
+      integer iP, iT, iQ
+      double precision P(1:Nmax), T(1:Nmax), Q(1:Nmax)
+
+      spch=' '
+
+      print*,'Name of atmosphere / planet:'
+      read*,planet_descriptor
+
+      composition_file='./composition.in'
+
+!     ! nmolec=2 ! total number of molecules
+
+      ! load temperature, pressure, mixing ratio data
+      open(9,file='T.dat')
+      read(9,*) iT
+      do i=1,iT
+         read(9,*) T(i)
+      enddo
+      close(9)
+
+      open(10,file='p.dat')
+      read(10,*) iP
+      do i=1,iP
+         read(10,*) P(i)
+         P(i)=10.**P(i)/1013.25
+      enddo
+      close(10)
+
+      open(11,file='Q.dat')
+      read(11,*) nmolec
+
+      print*,'nmolec=',nmolec
+
+      do mol=1,nmolec
+         read(11,*) molec_names(mol)
+      enddo
+      read(11,*) iQ
+      do i=1,iQ
+         read(11,*) Q(i)
+      enddo
+      close(11)
+
+      m=iP*iT*iQ ! total number of layers
+
+      print*,'Temperature layers:  ',iT
+      print*,'Pressure layers:     ',iP
+      print*,'Mixing ratio layers: ',iQ
+      print*,'Total:               ',m
+
+      do mol=1,nmolec-1
+         print*,'Please enter vmr of ',molec_names(mol)
+         read(*,*) xconst(mol)
+      end do
+
+     
+      do i=1,iQ
+         do j=1,iP              
+            do k=1,iT
+
+               im = (i-1)*iP*iT + (j-1)*iT + k
+
+               alt(im)=0.D0
+               pres(im)=P(j)
+               temp(im)=T(k)
+
+               do mol=1,nmolec-1
+                  x(im,mol)=xconst(mol)*(1.0-Q(i))
+               enddo
+               x(im,nmolec)=Q(i)
+
+            enddo
+         enddo
+      enddo
+
+      open(12,file=composition_file(1:strlen(composition_file)))
+      string='Atmospheric composition input '
+      string=string(1:strlen(string))//' data file for planet:'
+      string=string(1:strlen(string))//' '//
+
+     &     planet_descriptor(1:strlen(planet_descriptor))
+      write(12,'(a)') string(1:strlen(string))
+      write(12,39) 'Number of atmospheric levels: ',m
+      write(12,34) 'Number of molecules: ',nmolec
+      write(12,*) 
+      string='      z (km)     /    P (atm)     /     T (K) *'
+
+
+      do mol=1,nmolec
+
+         molname=molec_names(mol)
+
+         nb=5
+         if (strlen(molname).eq.1) then
+            na=7
+         else if (strlen(molname).eq.2) then
+            na=6
+         else if (strlen(molname).eq.3) then
+            na=5
+         endif
+         s='*'
+         do ne=1,nb
+            s=s(1:strlen(s)-1)//spch//'*'
+         enddo
+         s=s(1:strlen(s)-1)//'/*'
+         do ne=1,na
+            s=s(1:strlen(s)-1)//spch//'*'
+         enddo
+         
+         string=string(1:strlen(string)-1)
+     &        //s(1:strlen(s)-1)
+     &        //'x['
+     &        //molname(1:strlen(molname))
+     &        //']*'
+      enddo
+      write(12,*) string(1:strlen(string)-1)
+
+      do im=1,m
+
+         do mol=1,nmolec
+            xlev(mol)=x(im,mol)
+         enddo                  ! mol
+
+         write(12,50) alt(im),pres(im),temp(im),(xlev(mol),mol=1,nmolec)
+
+      enddo
+
+      write(12,*) 
+      close(12)
+
+      write(*,*) 'Output file successfully generated:'
+      write(*,*) composition_file(1:strlen(composition_file))
+      
+      end
Index: /trunk/LMDZ.GENERIC/utilities/max.inc
===================================================================
--- /trunk/LMDZ.GENERIC/utilities/max.inc	(revision 253)
+++ /trunk/LMDZ.GENERIC/utilities/max.inc	(revision 253)
@@ -0,0 +1,23 @@
+          integer Nline_mx,Nmol_max,Niso_max,Nbmx,Nkmx,Nmax,Nlpnb_mx
+	    integer Nxtab_mx,Nacc_mx,Nmax_tab,Nytab_mx,Nktab_mx
+	    integer nfiles_mx,Nproc_mx,Nchunk_mx,Nc_mx,Nmax_vt,Nppc_max
+	    integer Nti_mx
+          parameter(Nline_mx=2000000)
+          parameter(Nmol_max=42)
+          parameter(Niso_max=15)
+	  parameter(Nbmx=10000)
+	  parameter(Nkmx=100000)
+	  parameter(Nmax=2000)
+	  parameter(Nlpnb_mx=500000)
+	  parameter(Nxtab_mx=100000)
+	  parameter(Nacc_mx=1000)
+	  parameter(Nmax_tab=1000000)
+	    parameter(Nytab_mx=210)
+	    parameter(Nktab_mx=1000000)
+	    parameter(nfiles_mx=100)
+	    parameter(Nproc_mx=1000)
+	    parameter(Nchunk_mx=1000)
+	    parameter(Nc_mx=9)
+	    parameter(Nmax_vt=1000000)
+	    parameter(Nppc_max=10000)
+	    parameter(Nti_mx=100000)
Index: /trunk/LMDZ.GENERIC/utilities/postkspectrum
===================================================================
--- /trunk/LMDZ.GENERIC/utilities/postkspectrum	(revision 253)
+++ /trunk/LMDZ.GENERIC/utilities/postkspectrum	(revision 253)
@@ -0,0 +1,47 @@
+#!/bin/bash
+
+DWORK_DIR=/san/home/rdword/corrk_data/therm_test2
+KSPEC_DIR=/san/home/rdword/kspectrum/kspec_1
+BANDS_DIR=32x36
+
+### if hires_spectrum don't exist then create it, copy data from kspectrum
+DIRCHECK=hires_spectrum
+cd $DWORK_DIR/
+if [ -d $DIRCHECK ]; then
+    echo -en "Directory hires_spectrum already exists.\n"
+else
+    echo -en "Copying kspectrum data to its new home...\n"
+    cd $DWORK_DIR
+    mkdir hires_spectrum
+
+    mv $KSPEC_DIR/results/k* hires_spectrum/
+    cp $KSPEC_DIR/results/calculation_info.txt hires_spectrum/
+    cp $KSPEC_DIR/*in hires_spectrum/
+    cp $KSPEC_DIR/data/composition.in hires_spectrum/
+
+    # removing contents of 'optimizations' folder
+    rm -rf $KSPEC_DIR/optimizations
+    mkdir $KSPEC_DIR/optimizations
+
+    chmod 444 hires_spectrum/*
+fi
+
+cp ~/utilities/run_kmatrix .
+
+echo -en "\nNow you must submit the parallel job (>> llsubmit run_kmatrix)\n"
+
+exit 0
+
+#cp ~/utilities/generate_kmatrix.exe .
+### make kmatrix in the infrared and save it in a GCM-friendly format
+#cp $BANDS_DIR/narrowbands_IR.in narrowbands.in
+#generate_kmatrix.exe
+#mv corrk_gcm.dat $BANDS_DIR/corrk_gcm_IR.dat 
+#rm narrowbands.in
+### make kmatrix in the visible and save it in a GCM-friendly format
+#cp $BANDS_DIR/narrowbands_VI.in narrowbands.in
+#generate_kmatrix.exe
+#mv corrk_gcm.dat $BANDS_DIR/corrk_gcm_VI.dat 
+#rm narrowbands.in
+#rm generate_kmatrix.exe
+#exit 0
Index: /trunk/LMDZ.GENERIC/utilities/prekspectrum
===================================================================
--- /trunk/LMDZ.GENERIC/utilities/prekspectrum	(revision 253)
+++ /trunk/LMDZ.GENERIC/utilities/prekspectrum	(revision 253)
@@ -0,0 +1,26 @@
+#!/bin/bash
+
+DWORK_DIR=/san/home/rdword/corrk_data/therm_test2
+KSPEC_DIR=/san/home/rdword/kspectrum/kspec_1
+
+cd $DWORK_DIR
+
+# test for presence of k* in kspec results directory
+FILECHECK=$KSPEC_DIR/results/k001
+if [ -f $FILECHECK ]; then
+    echo -en "There is already k-data in the kspec directory "
+    echo -en $KSPEC_DIR
+    echo -en ", delete or move it before starting!\n"
+    exit 1
+fi
+
+#make_composition_gen.exe
+cp composition.in $KSPEC_DIR/data/
+
+echo -en "kspectrum working directory is:\n"
+echo -en $KSPEC_DIR
+echo -en "\nNow you must submit the parallel job (>> llsubmit run_kspec)\n"
+
+cd $KSPEC_DIR
+
+exit 0
Index: /trunk/LMDZ.GENERIC/utilities/run_kmatrix
===================================================================
--- /trunk/LMDZ.GENERIC/utilities/run_kmatrix	(revision 253)
+++ /trunk/LMDZ.GENERIC/utilities/run_kmatrix	(revision 253)
@@ -0,0 +1,28 @@
+# @ job_name=kmatrix
+# @ output = $(job_name).$(jobid)
+# @ error = $(output)
+# @ job_type = serial
+# @ class = B
+# @ queue
+
+BANDS_DIR=32x36
+
+cp ~/utilities/generate_kmatrix.exe .
+
+## make kmatrix in the infrared and save it in a GCM-friendly format
+cp $BANDS_DIR/narrowbands_IR.in narrowbands.in
+generate_kmatrix.exe #> log.out
+mv corrk_gcm.dat $BANDS_DIR/corrk_gcm_IR.dat 
+mv log.out $BANDS_DIR/logIR.out 
+rm narrowbands.in
+
+## make kmatrix in the visible and save it in a GCM-friendly format
+cp $BANDS_DIR/narrowbands_VI.in narrowbands.in
+generate_kmatrix.exe > log.out
+mv corrk_gcm.dat $BANDS_DIR/corrk_gcm_VI.dat 
+mv log.out $BANDS_DIR/logVI.out 
+rm narrowbands.in
+
+rm generate_kmatrix.exe
+
+exit 0
Index: /trunk/LMDZ.GENERIC/utilities/startrestart
===================================================================
--- /trunk/LMDZ.GENERIC/utilities/startrestart	(revision 253)
+++ /trunk/LMDZ.GENERIC/utilities/startrestart	(revision 253)
@@ -0,0 +1,6 @@
+#!/bin/bash
+
+mv -f restart.nc start.nc
+mv -f restartfi.nc startfi.nc
+
+exit 0
Index: /trunk/LMDZ.GENERIC/utilities/startrestart0
===================================================================
--- /trunk/LMDZ.GENERIC/utilities/startrestart0	(revision 253)
+++ /trunk/LMDZ.GENERIC/utilities/startrestart0	(revision 253)
@@ -0,0 +1,6 @@
+#!/bin/bash
+
+mv -f restart.nc start0.nc
+mv -f restartfi.nc startfi0.nc
+
+exit 0
Index: /trunk/LMDZ.GENERIC/utilities/strlen.for
===================================================================
--- /trunk/LMDZ.GENERIC/utilities/strlen.for	(revision 253)
+++ /trunk/LMDZ.GENERIC/utilities/strlen.for	(revision 253)
@@ -0,0 +1,10 @@
+      integer function strlen(st)
+      integer i
+      character st*(*)
+      i=len(st)
+      do while (st(i:i).eq.' ')
+         i=i-1
+      enddo
+      strlen=i
+      return
+      end
